/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GD.Connection.ETUD;

import GD.Connection.IGazeSource;
import GD.Data.IGazeContainer;
import java.io.File;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author skim
 */
public class ETUDGazeSource implements IGazeSource {
    //private SinkThread mDriverThread;
    private IGazeContainer mContainer;
    
    public ETUDGazeSource(IGazeContainer container){
        mContainer = container;
    }
    
    @Override
    public String Info() {
        return "JNA based sink for Eye-Tracker Universal Driver";
    }

    @Override
    public void Initialize() {
        ISink.INSTANCE.Initialize(new SampleCallback(mContainer),
                new FixationCallback(mContainer),
                new BlinkCallback(mContainer));
    }
    
    public boolean IsTracking(){
        return ISink.INSTANCE.IsTracking();
    }

    @Override
    public void DeInitialize() {
    //    ISink.INSTANCE.DeInitialize();
    }

    @Override
    public void StartTracking() {
      ISink.INSTANCE.StartTracking();
    }

    @Override
    public void StopTracking() {
      ISink.INSTANCE.StopTracking();
    }

    @Override
    public void ShowOptions() {
        ISink.INSTANCE.Options();
    }

    @Override
    public void ShowSources() {
        ISink.INSTANCE.Source();
    }

    @Override
    public void Calibration() {
        ISink.INSTANCE.Calibrate();
    }
}
