package GD.Data;

import java.awt.Color;
import java.util.Random;

public class GazeClient implements IGazeClient {
	/** Maximum name length */
	public final static int MAX_NAME_LENGTH = 8;
	/** Maximum description length */
	public final static int MAX_DESCRIPTION_LENGTH = 256;

	/** Client Id number - main identification attribute of the client */
	private int mId;

	/** Client name */
	private String mName;

	/** Client description. */
	private String mDescription;

	/** Marks client as drawable */
	private boolean mVisible;

	/** Container for gaze entries */
	private IGazeContainer mGazeContainer;

	/** Define the color of map mark */
	private Color mColor;

	public GazeClient(int i) {
            mId = i;
            mGazeContainer = new GazeContainer();
            
            Random rnd =  new Random();
            mColor = new Color(rnd.nextInt(255), rnd.nextInt(255),rnd.nextInt(255), 128);
            
            mVisible = true;
	}

	@Override
	public IGazeContainer GazeContainer() {
		return mGazeContainer;
	}

	@Override
	public String getName() {
		return mName;
	}

	@Override
	public void setName(String name) {
		if (name.length() > MAX_NAME_LENGTH)
			name = name.substring(0, MAX_NAME_LENGTH-1);
		
		mName = name;
	}

	@Override
	public boolean getVisibility() {
		return mVisible;
	}

	@Override
	public void setVisibility(boolean v) {
		mVisible = v;
	}

	@Override
	public java.awt.Color getColor() {
		return mColor;
	}

	@Override
	public void setColor(java.awt.Color c) {
		mColor = c;
	}
	
	public String toString() {
		return "Client " + String.valueOf(mId) + ": " + mName;
	}

	@Override
	public int ID() {
		return (int)mId;
	}

	@Override
	public String getDescription() {
		return mDescription;
	}

	@Override
	public void setDescription(String description) {
		if (description.length() > MAX_DESCRIPTION_LENGTH)
			description = description.substring(0, MAX_DESCRIPTION_LENGTH-1);
		
		mDescription = description;
	}
}
