package GD.Graphics;

import java.awt.Graphics;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.geom.Rectangle2D;

/**
 * Simple oval gaze data mark.
 * 
 * 
 * @version 2.0.0
 * @author Andrey Shipilov
 */

class MarkOvalPointer extends GazeMarkBase {
	Rectangle2D mPointSize;

	public MarkOvalPointer(String typeName) {
            super(typeName);
            mPointSize = new Rectangle(5, 5);
	}

	public Rectangle2D draw(Graphics g, Point coords) {
            Rectangle2D outRect = getSize();
            if (g != null) {
                outRect.setRect(coords.x - outRect.getWidth() / 2,
                    coords.y - outRect.getHeight() / 2, outRect.getWidth(),
                    outRect.getHeight());
		g.fillOval((int) outRect.getX(), (int) outRect.getY(),
                    (int) outRect.getWidth(), (int) outRect.getHeight());

		g.setColor(g.getColor().darker().darker());
		g.fillOval(coords.x - (int) mPointSize.getWidth() / 2, 
                    coords.y - (int) mPointSize.getHeight() / 2,
                    (int) mPointSize.getWidth(), (int) mPointSize.getHeight());
		}

		return outRect;
	}
}
